package com.cf.imes.module.executor.service.module;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.cf.imes.module.executor.controller.admin.module.vo.*;
import com.cf.imes.module.executor.dal.dataobject.module.ModuleDO;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.common.pojo.PageParam;
import com.cf.imes.framework.common.util.object.BeanUtils;

import com.cf.imes.module.executor.dal.mysql.module.ModuleMapper;

import static com.cf.imes.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.cf.imes.module.executor.enums.ErrorCodeConstants.*;

/**
 * 生产单模块 Service 实现类
 *
 * @author 晨丰科技
 */
@Service
@Validated
public class ModuleServiceImpl implements ModuleService {

    @Resource
    private ModuleMapper moduleMapper;

    @Override
    public Long createModule(ModuleSaveReqVO createReqVO) {
        // 插入
        ModuleDO module = BeanUtils.toBean(createReqVO, ModuleDO.class);
        moduleMapper.insert(module);
        // 返回
        return module.getId();
    }

    @Override
    public void updateModule(ModuleSaveReqVO updateReqVO) {
        // 校验存在
        validateModuleExists(updateReqVO.getId());
        // 更新
        ModuleDO updateObj = BeanUtils.toBean(updateReqVO, ModuleDO.class);
        moduleMapper.updateById(updateObj);
    }

    @Override
    public void deleteModule(Long id) {
        // 校验存在
        validateModuleExists(id);
        // 删除
        moduleMapper.deleteById(id);
    }

    private void validateModuleExists(Long id) {
        if (moduleMapper.selectById(id) == null) {
            throw exception(MODULE_NOT_EXISTS);
        }
    }

    @Override
    public ModuleDO getModule(Long id) {
        return moduleMapper.selectById(id);
    }

    @Override
    public PageResult<ModuleDO> getModulePage(ModulePageReqVO pageReqVO) {
        return moduleMapper.selectPage(pageReqVO);
    }

}